# Build configuration

%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%else
%define build_docs 1
%endif

%bcond_without examples

# Versioning

%define qtmajor 6
%define qtminor 7
%define qtsubminor 3
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define rel 1

%define snapshot 0

%if 0%{?snapshot}
%define pre rc
%endif

%define qttarballdir qtquick3d-everywhere-src-%{qtversion}%{?pre:-%{pre}}

# Library names

%define libqtquick3d            %mklibname qt%{qtmajor}quick3d %{qtmajor}
%define libqtquick3dassetimport %mklibname qt%{qtmajor}quick3dassetimport %{qtmajor}
%define libqtquick3diblbaker    %mklibname qt%{qtmajor}quick3diblbaker %{qtmajor}
%define libqtquick3dparticles   %mklibname qt%{qtmajor}quick3dparticles %{qtmajor}
%define libqtquick3druntime     %mklibname qt%{qtmajor}quick3druntimerender %{qtmajor}
%define libqtquick3dutils       %mklibname qt%{qtmajor}quick3dutils %{qtmajor}
%define libqtquick3dassetutils  %mklibname qt%{qtmajor}quick3dassetutils %{qtmajor}
%define libqtquick3deffects     %mklibname qt%{qtmajor}quick3deffects %{qtmajor}
%define libqtquick3dhelpers     %mklibname qt%{qtmajor}quick3dhelpers %{qtmajor}
%define libqtquick3dhelpersimpl %mklibname qt%{qtmajor}quick3dhelpersimpl %{qtmajor}
%define libqtquick3dglslparser  %mklibname qt%{qtmajor}quick3dglslparser %{qtmajor}
%define libqtquick3dpeffects    %mklibname qt%{qtmajor}quick3dparticleeffects %{qtmajor}

%define libqtquick3d_d          %mklibname qt%{qtmajor}quick3d -d

Name:           qtquick3d6
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} Quick 3D bindings and C++ APIs component
# See LICENSE.GPL LICENSE.LGPL LGPL_EXCEPTION.txt, for details
# See also http://doc.qt.io/qt-5/licensing.html
License:        LGPLv2 with exceptions or GPLv3 with exceptions
Group:          Development/KDE and Qt
Url:            https://www.qt.io/
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
## Patch from Fedora

## Branch Patchs

## Trunk Patchs

## Patch from Mageia

BuildRequires:  cmake
BuildRequires:  ninja
BuildRequires:  qtbase6-qtpaths

BuildRequires:  cmake(Qt6Core) >= %{version}
BuildRequires:  cmake(Qt6Gui) >= %{version}
BuildRequires:  cmake(Qt6OpenGL) >= %{version}
BuildRequires:  cmake(Qt6Qml) >= %{version}
BuildRequires:  cmake(Qt6QmlIntegration) >= %{version}
BuildRequires:  cmake(Qt6Quick) >= %{version}
BuildRequires:  cmake(Qt6ShaderTools) >= %{version}
BuildRequires:  cmake(Qt6Widgets) >= %{version}
BuildRequires:  cmake(Qt6Concurrent) >= %{version}
BuildRequires:  cmake(Qt6QuickTimeline) >= %{version}

BuildRequires:  qtimageformats6-devel >= %{version}

BuildRequires:  pkgconfig(assimp)

Requires:       qtimageformats6 >= %{version}

Provides:       qt%{qtmajor}-qtquick3d = %{version}-%{release}

%description
Qt%{qtmajor} Quick 3D provides everything necessary build Qt Quick 3D.
Qt Quick 3D is a high level 3D API for Qt Quick. Qt Quick 3D enables
anyone to introduce 3D content into their Qt Quick applications.
Rather than requiring the end user to know advanced details of the
graphics rendering pipeline (building framegraphs and materials), it
is now possible to simply build up a 3D scene using high level primitives.
It is a new module and API for defining 3D content in Qt Quick.

%files
%doc README.md
%{_bindir}/balsam-qt6
%{_qt6_bindir}/balsam
%{_bindir}/meshdebug-qt6
%{_qt6_bindir}/meshdebug
%{_bindir}/shadergen-qt6
%{_qt6_bindir}/shadergen
%{_bindir}/balsamui
%{_qt6_bindir}/balsamui
%{_bindir}/instancer
%{_qt6_bindir}/instancer
%{_bindir}/materialeditor
%{_qt6_bindir}/materialeditor
%{_bindir}/shapegen
%{_qt6_bindir}/shapegen
%{_qt6_qmldir}/QtQuick3D/
%{_qt6_plugindir}/assetimporters/

#------------------------------------------------------------------------------

%if %{build_docs}
%package        doc
Summary:        QtQuick3D%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools6
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools6-assistant
Recommends:     qttools6-assistant

%description doc
Documentation for APIs and tools in QtQuick3D%{qtmajor} package for
use with Qt Assistant.

%files doc
%{_qt6_docdir}/qtquick3d.qch
%{_qt6_docdir}/qtquick3d/
%endif

#------------------------------------------------------------------------------

%package -n     %{libqtquick3d}
Summary:        Qt%{qtmajor} Quick 3D Library
Group:          System/Libraries
Requires:       %{name} = %{version}

%description -n %{libqtquick3d}
Qt%{qtmajor} Quick 3D Component Library.

%files -n %{libqtquick3d}
%{_qt6_libdir}/libQt6Quick3D.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dassetimport}
Summary:        Qt%{qtmajor} Quick 3D Asset Import Library
Group:          System/Libraries

%description -n %{libqtquick3dassetimport}
Qt%{qtmajor} Quick 3D Asset Import Component Library.

%files -n %{libqtquick3dassetimport}
%{_qt6_libdir}/libQt6Quick3DAssetImport.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3diblbaker}
Summary:        Qt%{qtmajor} Quick 3D Ibl Baker Library
Group:          System/Libraries

%description -n %{libqtquick3diblbaker}
Qt%{qtmajor} Quick 3D Ibl Baker Component Library.

%files -n %{libqtquick3diblbaker}
%{_qt6_libdir}/libQt6Quick3DIblBaker.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dparticles}
Summary:        Qt%{qtmajor} Quick 3D Particles Library
Group:          System/Libraries

%description -n %{libqtquick3dparticles}
Qt%{qtmajor} Quick 3D Particles Component Library.

%files -n %{libqtquick3dparticles}
%{_qt6_libdir}/libQt6Quick3DParticles.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3druntime}
Summary:        Qt%{qtmajor} Quick 3D Runtime Render Library
Group:          System/Libraries

%description -n %{libqtquick3druntime}
Qt%{qtmajor} Quick 3D Runtime Render Component Library.

%files -n %{libqtquick3druntime}
%{_qt6_libdir}/libQt6Quick3DRuntimeRender.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dutils}
Summary:        Qt%{qtmajor} Quick 3D Utils Library
Group:          System/Libraries

%description -n %{libqtquick3dutils}
Qt%{qtmajor} Quick 3D Utils Component Library.

%files -n %{libqtquick3dutils}
%{_qt6_libdir}/libQt6Quick3DUtils.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dassetutils}
Summary:        Qt%{qtmajor} Quick 3D Asset Utils Library
Group:          System/Libraries

%description -n %{libqtquick3dassetutils}
Qt%{qtmajor} Quick 3D Asset Utils Component Library.

%files -n %{libqtquick3dassetutils}
%{_qt6_libdir}/libQt6Quick3DAssetUtils.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3deffects}
Summary:        Qt%{qtmajor} Quick 3D Effects Library
Group:          System/Libraries

%description -n %{libqtquick3deffects}
Qt%{qtmajor} Quick 3D Effects Component Library.

%files -n %{libqtquick3deffects}
%{_qt6_libdir}/libQt6Quick3DEffects.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dhelpers}
Summary:        Qt%{qtmajor} Quick 3D Helpers Library
Group:          System/Libraries

%description -n %{libqtquick3dhelpers}
Qt%{qtmajor} Quick 3D Helpers Component Library.

%files -n %{libqtquick3dhelpers}
%{_qt6_libdir}/libQt6Quick3DHelpers.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dhelpersimpl}
Summary:        Qt%{qtmajor} Quick 3D Helpers Impl Library
Group:          System/Libraries

%description -n %{libqtquick3dhelpersimpl}
Qt%{qtmajor} Quick 3D Helpers Impl Component Library.

%files -n %{libqtquick3dhelpersimpl}
%{_qt6_libdir}/libQt6Quick3DHelpersImpl.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dglslparser}
Summary:        Qt%{qtmajor} Quick 3D Glsl Parser Library
Group:          System/Libraries

%description -n %{libqtquick3dglslparser}
Qt%{qtmajor} Quick 3D Glsl Parser Component Library.

%files -n %{libqtquick3dglslparser}
%{_qt6_libdir}/libQt6Quick3DGlslParser.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3dpeffects}
Summary:        Qt%{qtmajor} Quick 3D Particle Effects Library
Group:          System/Libraries

%description -n %{libqtquick3dpeffects}
Qt%{qtmajor} Quick 3D Particle Effects Component Library.

%files -n %{libqtquick3dpeffects}
%{_qt6_libdir}/libQt6Quick3DParticleEffects.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtquick3d_d}
Summary:        Devel files needed to build apps based on QtQuick3D
Group:          Development/KDE and Qt
Requires:       %{libqtquick3d} = %{version}
Requires:       %{libqtquick3dassetimport} = %{version}
Requires:       %{libqtquick3diblbaker} = %{version}
Requires:       %{libqtquick3dparticles} = %{version}
Requires:       %{libqtquick3druntime} = %{version}
Requires:       %{libqtquick3dutils} = %{version}
Requires:       %{libqtquick3dassetutils} = %{version}
Requires:       %{libqtquick3deffects} = %{version}
Requires:       %{libqtquick3dhelpers} = %{version}
Requires:       %{libqtquick3dhelpersimpl} = %{version}
Requires:       %{libqtquick3dglslparser} = %{version}
Requires:       %{libqtquick3dpeffects} = %{version}
Provides:       libqtquick3d6-devel = %{version}
Provides:       libqt6quick3d-devel = %{version}
Provides:       qtquick3d6-devel = %{version}
Provides:       qt6quick3d-devel = %{version}
Provides:       qt%{qtmajor}-qtquick3d-devel = %{version}-%{release}

%description -n %{libqtquick3d_d}
Devel files needed to build apps based on Qt Quick 3D.

%files -n %{libqtquick3d_d}
%{_qt6_includedir}/QtQuick3D/
%{_qt6_libdir}/libQt6Quick3D.so
%{_qt6_libdir}/libQt6Quick3D.prl
%{_qt6_libdir}/cmake/Qt6Quick3D/
%{_qt6_libdir}/cmake/Qt6Quick3DTools/
%{_qt6_libdir}/qt6/metatypes/qt6quick3d_*_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3D.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3D.pc
#
%{_qt6_includedir}/QtQuick3DGlslParser/
%{_qt6_libdir}/libQt6Quick3DGlslParser.so
%{_qt6_libdir}/libQt6Quick3DGlslParser.prl
%{_qt6_libdir}/cmake/Qt6Quick3DGlslParserPrivate/
%{_qt6_libdir}/qt6/metatypes/qt6quick3dglslparserprivate_*_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3DGlslParserPrivate.json
#
%{_qt6_libdir}/libQt6Quick3DParticleEffects.so
%{_qt6_libdir}/libQt6Quick3DParticleEffects.prl
%{_qt6_libdir}/cmake/Qt6Quick3DParticleEffects/
%{_qt6_libdir}/qt6/metatypes/qt6quick3dparticleeffects_*_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3DParticleEffects.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DParticleEffects.pc
#
%{_qt6_includedir}/QtQuick3DAssetImport/
%{_qt6_libdir}/libQt6Quick3DAssetImport.so
%{_qt6_libdir}/libQt6Quick3DAssetImport.prl
%{_qt6_libdir}/cmake/Qt6Quick3DAssetImport/
%{_qt6_libdir}/qt6/modules/Quick3DAssetImport.json
%{_qt6_libdir}/qt6/metatypes/qt6quick3dassetimport_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/metatypes/qt6quick3dassetutils_relwithdebinfo_metatypes.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DAssetImport.pc
#
%{_qt6_includedir}/QtQuick3DIblBaker/
%{_qt6_libdir}/libQt6Quick3DIblBaker.so
%{_qt6_libdir}/libQt6Quick3DIblBaker.prl
%{_qt6_libdir}/cmake/Qt6Quick3DIblBaker/
%{_qt6_libdir}/qt6/modules/Quick3DIblBaker.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DIblBaker.pc
#
%{_qt6_includedir}/QtQuick3DParticles/
%{_qt6_libdir}/libQt6Quick3DParticles.so
%{_qt6_libdir}/libQt6Quick3DParticles.prl
%{_qt6_libdir}/cmake/Qt6Quick3DParticles/
%{_qt6_libdir}/qt6/metatypes/qt6quick3dparticles_*_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3DParticles.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DParticles.pc
#
%{_qt6_includedir}/QtQuick3DRuntimeRender/
%{_qt6_libdir}/libQt6Quick3DRuntimeRender.so
%{_qt6_libdir}/libQt6Quick3DRuntimeRender.prl
%{_qt6_libdir}/cmake/Qt6Quick3DRuntimeRender/
%{_qt6_libdir}/qt6/modules/Quick3DRuntimeRender.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DRuntimeRender.pc
#
%{_qt6_includedir}/QtQuick3DUtils/
%{_qt6_libdir}/libQt6Quick3DUtils.so
%{_qt6_libdir}/libQt6Quick3DUtils.prl
%{_qt6_libdir}/cmake/Qt6Quick3DUtils/
%{_qt6_libdir}/qt6/modules/Quick3DUtils.json
%{_qt6_libdir}/qt6/metatypes/qt6quick3dutils_relwithdebinfo_metatypes.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DUtils.pc
#
%{_qt6_includedir}/QtQuick3DAssetUtils/
%{_qt6_libdir}/cmake/Qt6Quick3DAssetUtils/
%{_qt6_libdir}/libQt6Quick3DAssetUtils.prl
%{_qt6_libdir}/libQt6Quick3DAssetUtils.so
%{_qt6_libdir}/qt6/modules/Quick3DAssetUtils.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DAssetUtils.pc
#
%{_qt6_includedir}/QtQuick3DHelpers/
%{_qt6_libdir}/cmake/Qt6Quick3DHelpers/
%{_qt6_libdir}/libQt6Quick3DHelpers.prl
%{_qt6_libdir}/libQt6Quick3DHelpers.so
%{_qt6_libdir}/qt6/metatypes/qt6quick3dhelpers_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3DHelpers.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DHelpers.pc
#
%{_qt6_includedir}/QtQuick3DHelpersImpl/
%{_qt6_libdir}/cmake/Qt6Quick3DHelpersImpl/
%{_qt6_libdir}/libQt6Quick3DHelpersImpl.prl
%{_qt6_libdir}/libQt6Quick3DHelpersImpl.so
%{_qt6_libdir}/qt6/metatypes/qt6quick3dhelpersimpl_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3DHelpersImpl.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DHelpersImpl.pc
#
%{_qt6_libdir}/cmake/Qt6Quick3DEffects/
%{_qt6_libdir}/libQt6Quick3DEffects.prl
%{_qt6_libdir}/libQt6Quick3DEffects.so
%{_qt6_libdir}/qt6/metatypes/qt6quick3deffects_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/Quick3DEffects.json
%{_qt6_libdir}/pkgconfig/Qt6Quick3DEffects.pc
#
%ifarch %{arm64} x86_64
%{_qt6_libdir}/cmake/Qt6/FindWrapBundledEmbreeConfigExtra.cmake
%{_qt6_libdir}/cmake/Qt6BundledEmbree/
%{_qt6_libdir}/libQt6BundledEmbree.a
%endif
#
%{_qt6_libdir}/cmake/Qt6BuildInternals/StandaloneTests/QtQuick3DTestsConfig.cmake
%{_qt6_libdir}/cmake/Qt6/FindWrapQuick3DAssimp.cmake
%{_qt6_libdir}/cmake/Qt6Qml/QmlPlugins/*.cmake
%{_qt6_archdatadir}/mkspecs/modules/*.pri
%if %{with examples}
%{_qt6_examplesdir}/quick3d/
%endif
%{_qt6_libdir}/qt6/metatypes/qt6quick3druntimerender_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/metatypes/qt6quick3diblbaker_relwithdebinfo_metatypes.json

#------------------------------------------------------------------------------

%prep
%autosetup -p1 -n qtquick3d-everywhere-src-%{qtversion}

%build
%cmake_qt6 %{!?with_examples:-DQT_BUILD_EXAMPLES:BOOL=OFF}
#          -DQT_FEATURE_system_assimp:BOOL=ON

%cmake_build

%if %{build_docs}
%ninja_build -C build docs
%endif

%install
%cmake_install

%if %{build_docs}
%ninja_install -C build install_docs
%endif

# hardlink files to %%{_bindir}, add -qt6 postfix to not conflict
mkdir %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt6_bindir}
for i in * ; do
  case "${i}" in
    balsam|meshdebug|shadergen)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt6
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd


%changelog
* Sat Oct 05 2024 daviddavid <daviddavid> 6.7.3-1.mga10
+ Revision: 2103614
- New version 6.7.3
- enable docs building

* Wed Jul 31 2024 daviddavid <daviddavid> 6.7.2-1.mga10
+ Revision: 2083112
- New version 6.7.2

* Tue Jun 11 2024 daviddavid <daviddavid> 6.7.1-2.mga10
+ Revision: 2072539
- rebuild for 'Qt_$MAJOR_PRIVATE_API' settings

* Wed May 22 2024 daviddavid <daviddavid> 6.7.1-1.mga10
+ Revision: 2065878
- New version 6.7.1

* Thu Feb 15 2024 daviddavid <daviddavid> 6.6.2-1.mga10
+ Revision: 2041645
- New version 6.6.2

* Thu Oct 19 2023 daviddavid <daviddavid> 6.6.0-1.mga10
+ Revision: 1999041
- New version 6.6.0

* Mon Sep 11 2023 neoclust <neoclust> 6.5.2-1.mga10
+ Revision: 1986100
- New version 6.5.2

* Tue Dec 27 2022 daviddavid <daviddavid> 6.4.1-2.mga9
+ Revision: 1927062
- build examples

* Thu Dec 15 2022 neoclust <neoclust> 6.4.1-1.mga9
+ Revision: 1923050
- New version 6.4.1

* Tue Oct 04 2022 neoclust <neoclust> 6.4.0-2.mga9
+ Revision: 1894715
- Rebuild with fixed file list
- New version 6.4.0

* Sun Aug 28 2022 neoclust <neoclust> 6.3.1-1.mga9
+ Revision: 1881523
- New version 6.3.1

* Sun Jul 31 2022 wally <wally> 6.3.0-1.mga9
+ Revision: 1874033
- disable examples as they needs pkg itself to build
- add qtquick3dglslparser and qtquick3dparticleeffects libs
+ neoclust <neoclust>
- New version 6.3.0

* Tue Apr 05 2022 umeabot <umeabot> 6.2.3-2.mga9
+ Revision: 1845189
- Mageia 9 Mass Rebuild

* Sun Feb 20 2022 neoclust <neoclust> 6.2.3-1.mga9
+ Revision: 1781918
- New version 6.2.3

* Sun Nov 14 2021 neoclust <neoclust> 6.2.1-1.mga9
+ Revision: 1756252
- New version 6.2.1

* Sat Nov 13 2021 neoclust <neoclust> 6.2.0-2.mga9
+ Revision: 1756041
- Fix requires of new libraries
- New version 6.2.0

* Sat May 15 2021 daviddavid <daviddavid> 6.1.0-1.mga9
+ Revision: 1723342
- initial package qtquick3d6

